---
title: PluginArray
slug: Web/API/PluginArray
tags:
  - API
  - Add-ons
  - DOM
  - Experimental
  - NeedsContent
  - Plugins
---
<p>{{APIRef("HTML DOM")}}{{SeeCompatTable}}</p>

<p>The <code>PluginArray</code> interface is used to store a list of {{DOMxRef("Plugin")}} objects describing the available <a href="/en-US/docs/Mozilla/Add-ons/Plugins">plugins</a>; it's returned by the {{DOMxRef("window.navigator.plugins")}} property. The <code>PluginArray</code> is not a JavaScript array, but has the <code>length</code> property and supports accessing individual items using bracket notation (<code>plugins[2]</code>), as well as via <code>item(<var>index</var>)</code> and <code>namedItem(<em>"name"</em>)</code> methods.</p>

<div class="note">
<p><strong>Note</strong>: Own properties of <code>PluginArray</code> objects are no longer enumerable in the latest browser versions.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{DOMxRef("PluginArray.length")}}{{ReadOnlyInline}}</dt>
 <dd>The number of plugins in the array.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{DOMxRef("PluginArray.item")}}</dt>
 <dd>Returns the {{DOMxRef("Plugin")}} at the specified index into the array.</dd>
 <dt>{{DOMxRef("PluginArray.namedItem")}}</dt>
 <dd>Returns the {{DOMxRef("Plugin")}} with the specified name.</dd>
 <dt>{{DOMxRef("PluginArray.refresh")}}</dt>
 <dd>Refreshes all plugins on the current page, optionally reloading documents.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example function returns the version of the Shockwave Flash plugin.</p>

<pre class="brush:js">var pluginsLength = navigator.plugins.length;

document.body.innerHTML = pluginsLength + " Plugin(s)&lt;br&gt;"
  + '&lt;table id="pluginTable"&gt;&lt;thead&gt;'
  +'&lt;tr&gt;&lt;th&gt;Name&lt;/th&gt;&lt;th&gt;Filename&lt;/th&gt;&lt;th&gt;description&lt;/th&gt;&lt;th&gt;version&lt;/th&gt;&lt;/tr&gt;'
  +'&lt;/thead&gt;&lt;tbody&gt;&lt;/tbody&gt;&lt;/table&gt;';

var table = document.getElementById('pluginTable');

for(var i = 0; i &lt; pluginsLength; i++) {
  let newRow = table.insertRow();
  newRow.insertCell().textContent = navigator.plugins[i].name;
  newRow.insertCell().textContent = navigator.plugins[i].filename;
  newRow.insertCell().textContent = navigator.plugins[i].description;
  newRow.insertCell().textContent = navigator.plugins[i].version?navigator.plugins[i].version:"";
}</pre>

<p>The following example displays information about the installed plugin(s).</p>

<pre class="brush:js">var pluginsLength = navigator.plugins.length;

document.write(
  pluginsLength.toString() + " Plugin(s)&lt;br&gt;" +
  "Name | Filename | description&lt;br&gt;"
);

for(var i = 0; i &lt; pluginsLength; i++) {
  document.write(
    navigator.plugins[i].name +
    " | " +
    navigator.plugins[i].filename +
    " | " +
    navigator.plugins[i].description +
    " | " +
    navigator.plugins[i].version +
    "&lt;br&gt;"
  );
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#pluginarray", "PluginArray")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PluginArray")}}</p>

<p>In addition to listing each plugin as a pseudo-array by zero-indexed numeric properties, Firefox provides properties that are the plugin name directly on the PluginArray object.</p>
